> ## Documentation Index
> Fetch the complete documentation index at: https://api-reference.hyperswitch.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Payments - Confirm Intent

> **Confirms a payment intent object with the payment method data**

.



## OpenAPI

````yaml post /v2/payments/{id}/confirm-intent
openapi: 3.0.3
info:
  title: Hyperswitch - API Documentation
  description: >

    ## Get started


    Hyperswitch provides a collection of APIs that enable you to process and
    manage payments.

    Our APIs accept and return JSON in the HTTP body, and return standard HTTP
    response codes.


    You can consume the APIs directly using your favorite HTTP/REST library.


    We have a testing environment referred to "sandbox", which you can setup to
    test API calls without

    affecting production data.

    Currently, our sandbox environment is live while our production environment
    is under development

    and will be available soon.

    You can sign up on our Dashboard to get API keys to access Hyperswitch API.


    ### Environment


    Use the following base URLs when making requests to the APIs:


    | Environment   |  Base URL                          |

    |---------------|------------------------------------|

    | Sandbox       | <https://sandbox.hyperswitch.io>   |

    | Production    | <https://api.hyperswitch.io>       |


    ## Authentication


    When you sign up on our [dashboard](https://app.hyperswitch.io) and create a
    merchant

    account, you are given a secret key (also referred as api-key) and a
    publishable key.

    You may authenticate all API requests with Hyperswitch server by providing
    the appropriate key in

    the request Authorization header.


    | Key             | 
    Description                                                                                 
    |

    |-----------------|-----------------------------------------------------------------------------------------------|

    | api-key         | Private key. Used to authenticate all API requests from
    your merchant server                  |

    | publishable key | Unique identifier for your account. Used to authenticate
    API requests from your app's client  |


    Never share your secret api keys. Keep them guarded and secure.
  contact:
    name: Hyperswitch Support
    url: https://hyperswitch.io
    email: support.global@juspay.io
  license:
    name: Apache-2.0
  version: 0.1.0
servers:
  - url: https://sandbox.hyperswitch.io
    description: Sandbox Environment
security: []
tags:
  - name: Merchant Account
    description: Create and manage merchant accounts
  - name: Profile
    description: Create and manage profiles
  - name: Merchant Connector Account
    description: Create and manage merchant connector accounts
  - name: Payments
    description: Create and manage one-time payments, recurring payments and mandates
  - name: Refunds
    description: Create and manage refunds for successful payments
  - name: Mandates
    description: Manage mandates
  - name: Customers
    description: Create and manage customers
  - name: Payment Methods
    description: Create and manage payment methods of customers
  - name: Disputes
    description: Manage disputes
  - name: API Key
    description: Create and manage API Keys
  - name: Payouts
    description: Create and manage payouts
  - name: payment link
    description: Create payment link
  - name: Routing
    description: Create and manage routing configurations
  - name: Event
    description: Manage events
paths:
  /v2/payments/{id}/confirm-intent:
    post:
      tags:
        - Payments
      summary: Payments - Confirm Intent
      description: |-
        **Confirms a payment intent object with the payment method data**

        .
      operationId: Confirm Payment Intent
      parameters:
        - name: id
          in: path
          description: The unique identifier for the Payment Intent
          required: true
          schema:
            type: string
        - name: X-Profile-Id
          in: header
          description: Profile ID associated to the payment intent
          required: true
          schema:
            type: string
          example: pro_abcdefghijklmnop
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PaymentsConfirmIntentRequest'
            examples:
              Confirm the payment intent with card details:
                value:
                  payment_method_data:
                    card:
                      card_cvc: '123'
                      card_exp_month: '10'
                      card_exp_year: '25'
                      card_holder_name: joseph Doe
                      card_number: '4242424242424242'
                  payment_method_subtype: credit
                  payment_method_type: card
        required: true
      responses:
        '200':
          description: Payment created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaymentsResponse'
        '400':
          description: Missing Mandatory fields
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GenericErrorResponseOpenApi'
      security:
        - publishable_key__client_secret: []
components:
  schemas:
    PaymentsConfirmIntentRequest:
      type: object
      description: Request for Payment Intent Confirm
      required:
        - payment_method_data
        - payment_method_type
      properties:
        return_url:
          type: string
          description: >-
            The URL to which you want the user to be redirected after the
            completion of the payment operation

            If this url is not passed, the url configured in the business
            profile will be used
          example: https://hyperswitch.io
          nullable: true
        payment_method_data:
          $ref: '#/components/schemas/PaymentMethodDataRequest'
        split_payment_method_data:
          type: array
          items:
            $ref: '#/components/schemas/SplitPaymentMethodDataRequest'
          description: >-
            The payment instrument data to be used for the payment in case of
            split payments
          nullable: true
        payment_method_type:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_subtype:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        shipping:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        customer_acceptance:
          allOf:
            - $ref: '#/components/schemas/CustomerAcceptance'
          nullable: true
        browser_info:
          allOf:
            - $ref: '#/components/schemas/BrowserInformation'
          nullable: true
        payment_method_id:
          type: string
          description: The payment_method_id to be associated with the payment
          nullable: true
        payment_token:
          type: string
          example: 187282ab-40ef-47a9-9206-5099ba31e432
          nullable: true
        merchant_connector_details:
          allOf:
            - $ref: '#/components/schemas/MerchantConnectorAuthDetails'
          nullable: true
        return_raw_connector_response:
          type: boolean
          description: If true, returns stringified connector raw response body
          nullable: true
        webhook_url:
          type: string
          description: The webhook endpoint URL to receive payment status notifications
          example: https://merchant.example.com/webhooks/payment
          nullable: true
      additionalProperties: false
    PaymentsResponse:
      type: object
      description: >-
        Response for Payment Intent Confirm

        Few fields should be expandable, we need not return these in the normal
        response

        But when explicitly requested for expanded objects, these can be
        returned

        For example

        shipping, billing, customer, payment_method
      required:
        - id
        - status
        - amount
        - customer_id
        - processor_merchant_id
        - created
        - modified_at
      properties:
        id:
          type: string
          description: >-
            Unique identifier for the payment. This ensures idempotency for
            multiple payments

            that have been done by a single merchant.
          example: 0a_pay_01926c58bc6e77c09e809964e72af8c8
          maxLength: 64
          minLength: 32
        status:
          $ref: '#/components/schemas/IntentStatus'
        amount:
          $ref: '#/components/schemas/PaymentAmountDetailsResponse'
        customer_id:
          type: string
          description: The identifier for the customer
          example: 0a_cus_01926c58bc6e77c09e809964e72af8c8
          maxLength: 64
          minLength: 32
        processor_merchant_id:
          type: string
          description: >-
            The identifier for the processor merchant account. In
            platform-connected setups,

            this is the connected merchant ID. For standard merchants, this is
            same as merchant_id.
          example: merchant_1689512302
          maxLength: 255
        initiator:
          allOf:
            - $ref: '#/components/schemas/Initiator'
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
          example: stripe
          nullable: true
        created:
          type: string
          format: date-time
          description: Time when the payment was created
          example: '2022-09-10T10:11:12Z'
        modified_at:
          type: string
          format: date-time
          description: Time when the payment was last modified
          example: '2022-09-10T10:11:12Z'
        payment_method_data:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponseWithBilling'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethod'
          nullable: true
        payment_method_subtype:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        connector_transaction_id:
          type: string
          description: A unique identifier for a payment provided by the connector
          example: 993672945374576J
          nullable: true
        connector_reference_id:
          type: string
          description: reference(Identifier) to the payment at connector side
          example: 993672945374576J
          nullable: true
        merchant_connector_id:
          type: string
          description: >-
            Identifier of the connector ( merchant connector account ) which was
            chosen to make the payment
          nullable: true
        browser_info:
          allOf:
            - $ref: '#/components/schemas/BrowserInformation'
          nullable: true
        error:
          allOf:
            - $ref: '#/components/schemas/ErrorDetails'
          nullable: true
        shipping:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        billing:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        attempts:
          type: array
          items:
            $ref: '#/components/schemas/PaymentAttemptResponse'
          description: List of payment attempts associated with payment intent
          nullable: true
        connector_token_details:
          allOf:
            - $ref: '#/components/schemas/ConnectorTokenDetails'
          nullable: true
        payment_method_id:
          type: string
          description: The payment_method_id associated with the payment
          nullable: true
        next_action:
          allOf:
            - $ref: '#/components/schemas/NextActionData'
          nullable: true
        return_url:
          type: string
          description: >-
            The url to which user must be redirected to after completion of the
            purchase
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: no_three_ds
          nullable: true
        authentication_type_applied:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: no_three_ds
          nullable: true
        is_iframe_redirection_enabled:
          type: boolean
          description: Indicates if the redirection has to open in the iframe
          nullable: true
        merchant_reference_id:
          type: string
          description: >-
            Unique identifier for the payment. This ensures idempotency for
            multiple payments

            that have been done by a single merchant.
          example: pay_mbabizu24mvu3mela5njyhpit4
          nullable: true
          maxLength: 30
          minLength: 30
        raw_connector_response:
          type: string
          description: >-
            Stringified connector raw response body. Only returned if
            `return_raw_connector_response` is true
          nullable: true
        feature_metadata:
          allOf:
            - $ref: '#/components/schemas/FeatureMetadata'
          nullable: true
        metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. Metadata is useful for
            storing additional, structured information on an object.
          nullable: true
    GenericErrorResponseOpenApi:
      type: object
      required:
        - error_type
        - message
        - code
      properties:
        error_type:
          type: string
          example: invalid_request
        message:
          type: string
          example: 'Missing required param: {param}'
        code:
          type: string
          example: IR_04
    PaymentMethodDataRequest:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentMethodData'
          nullable: true
        - type: object
          properties:
            billing:
              allOf:
                - $ref: '#/components/schemas/Address'
              nullable: true
      description: The payment method information provided for making a payment
    SplitPaymentMethodDataRequest:
      type: object
      required:
        - payment_method_data
        - payment_method_type
        - payment_method_subtype
      properties:
        payment_method_data:
          $ref: '#/components/schemas/PaymentMethodData'
        payment_method_type:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_subtype:
          $ref: '#/components/schemas/PaymentMethodType'
    PaymentMethod:
      type: string
      description: 'Indicates the type of payment method. Eg: ''card'', ''wallet'', etc.'
      enum:
        - card
        - card_redirect
        - pay_later
        - wallet
        - bank_redirect
        - bank_transfer
        - crypto
        - bank_debit
        - reward
        - real_time_payment
        - upi
        - voucher
        - gift_card
        - open_banking
        - mobile_payment
        - network_token
    PaymentMethodType:
      type: string
      description: >-
        Indicates the sub type of payment method. Eg: 'google_pay' & 'apple_pay'
        for wallets.
      enum:
        - ach
        - affirm
        - afterpay_clearpay
        - alfamart
        - ali_pay
        - ali_pay_hk
        - alma
        - amazon_pay
        - paysera
        - apple_pay
        - atome
        - bacs
        - bancontact_card
        - becs
        - benefit
        - bizum
        - blik
        - bluecode
        - boleto
        - bca_bank_transfer
        - bni_va
        - breadpay
        - bri_va
        - bhn_card_network
        - card_redirect
        - cimb_va
        - classic
        - credit
        - crypto_currency
        - cashapp
        - dana
        - danamon_va
        - debit
        - duit_now
        - efecty
        - eft
        - eft_debit_order
        - eps
        - flexiti
        - fps
        - evoucher
        - giropay
        - givex
        - google_pay
        - go_pay
        - gcash
        - ideal
        - interac
        - indomaret
        - klarna
        - kakao_pay
        - local_bank_redirect
        - mandiri_va
        - knet
        - mb_way
        - mobile_pay
        - momo
        - momo_atm
        - multibanco
        - online_banking_thailand
        - online_banking_czech_republic
        - online_banking_finland
        - online_banking_fpx
        - online_banking_poland
        - online_banking_slovakia
        - oxxo
        - pago_efectivo
        - permata_bank_transfer
        - open_banking_uk
        - pay_bright
        - payjustnow
        - paypal
        - paze
        - pix
        - pix_key
        - pix_emv
        - pix_qr
        - pix_automatico_qr
        - pix_automatico_push
        - pay_safe_card
        - przelewy24
        - prompt_pay
        - pse
        - qris
        - red_compra
        - red_pagos
        - samsung_pay
        - sepa
        - sepa_bank_transfer
        - sepa_guarenteed_debit
        - skrill
        - sofort
        - swish
        - touch_n_go
        - trustly
        - twint
        - upi_collect
        - upi_intent
        - upi_qr
        - vipps
        - viet_qr
        - venmo
        - walley
        - we_chat_pay
        - seven_eleven
        - lawson
        - mini_stop
        - family_mart
        - seicomart
        - pay_easy
        - local_bank_transfer
        - mifinity
        - open_banking_pis
        - direct_carrier_billing
        - instant_bank_transfer
        - instant_bank_transfer_finland
        - instant_bank_transfer_poland
        - revolut_pay
        - indonesian_bank_transfer
        - open_banking
        - network_token
    Address:
      type: object
      properties:
        address:
          allOf:
            - $ref: '#/components/schemas/AddressDetails'
          nullable: true
        phone:
          allOf:
            - $ref: '#/components/schemas/PhoneDetails'
          nullable: true
        email:
          type: string
          nullable: true
    CustomerAcceptance:
      type: object
      description: >-
        This "CustomerAcceptance" object is passed during Payments-Confirm
        request, it enlists the type, time, and mode of acceptance properties
        related to an acceptance done by the customer. The customer_acceptance
        sub object is usually passed by the SDK or client.
      required:
        - acceptance_type
      properties:
        acceptance_type:
          $ref: '#/components/schemas/AcceptanceType'
        accepted_at:
          type: string
          format: date-time
          description: Specifying when the customer acceptance was provided
          example: '2022-09-10T10:11:12Z'
          nullable: true
        online:
          allOf:
            - $ref: '#/components/schemas/OnlineMandate'
          nullable: true
      additionalProperties: false
    BrowserInformation:
      type: object
      description: Browser information to be used for 3DS 2.0
      properties:
        color_depth:
          type: integer
          format: int32
          description: Color depth supported by the browser
          nullable: true
          minimum: 0
        java_enabled:
          type: boolean
          description: Whether java is enabled in the browser
          nullable: true
        java_script_enabled:
          type: boolean
          description: Whether javascript is enabled in the browser
          nullable: true
        language:
          type: string
          description: Language supported
          nullable: true
        screen_height:
          type: integer
          format: int32
          description: The screen height in pixels
          nullable: true
          minimum: 0
        screen_width:
          type: integer
          format: int32
          description: The screen width in pixels
          nullable: true
          minimum: 0
        time_zone:
          type: integer
          format: int32
          description: Time zone of the client
          nullable: true
        ip_address:
          type: string
          description: Ip address of the client
          nullable: true
        accept_header:
          type: string
          description: List of headers that are accepted
          example: >-
            text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8
          nullable: true
        user_agent:
          type: string
          description: User-agent of the browser
          nullable: true
        os_type:
          type: string
          description: The os type of the client device
          nullable: true
        os_version:
          type: string
          description: The os version of the client device
          nullable: true
        device_model:
          type: string
          description: The device model of the client
          nullable: true
        accept_language:
          type: string
          description: Accept-language of the browser
          nullable: true
        referer:
          type: string
          description: Identifier of the source that initiated the request.
          nullable: true
    MerchantConnectorAuthDetails:
      type: object
      description: Merchant connector details
      required:
        - connector_name
        - merchant_connector_creds
      properties:
        connector_name:
          $ref: '#/components/schemas/Connector'
        merchant_connector_creds:
          type: object
          description: The merchant connector credentials used for the payment
    IntentStatus:
      type: string
      description: >-
        Represents the overall status of a payment intent.

        The status transitions through various states depending on the payment
        method, confirmation, capture method, and any subsequent actions (like
        customer authentication or manual capture).
      enum:
        - succeeded
        - failed
        - cancelled
        - cancelled_post_capture
        - processing
        - requires_customer_action
        - requires_merchant_action
        - requires_payment_method
        - requires_confirmation
        - requires_capture
        - partially_captured
        - partially_captured_and_capturable
        - partially_authorized_and_requires_capture
        - partially_captured_and_processing
        - conflicted
        - expired
        - review
    PaymentAmountDetailsResponse:
      type: object
      required:
        - currency
        - external_tax_calculation
        - surcharge_calculation
        - net_amount
        - amount_capturable
      properties:
        order_amount:
          type: integer
          format: int64
          description: >-
            The payment amount. Amount for the payment in the lowest
            denomination of the currency, (i.e) in cents for USD denomination,
            in yen for JPY denomination etc. E.g., Pass 100 to charge $1.00 and
            1 for 1¥ since ¥ is a zero-decimal currency. Read more about [the
            Decimal and Non-Decimal
            Currencies](https://github.com/juspay/hyperswitch/wiki/Decimal-and-Non%E2%80%90Decimal-Currencies)
          example: 6540
          minimum: 0
        currency:
          $ref: '#/components/schemas/Currency'
        shipping_cost:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        order_tax_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        external_tax_calculation:
          $ref: '#/components/schemas/TaxCalculationOverride'
        surcharge_calculation:
          $ref: '#/components/schemas/SurchargeCalculationOverride'
        surcharge_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        tax_on_surcharge:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        net_amount:
          $ref: '#/components/schemas/MinorUnit'
        amount_to_capture:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        amount_capturable:
          $ref: '#/components/schemas/MinorUnit'
        amount_captured:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
    Initiator:
      type: string
      description: >-
        Represents the initiator context in platform-connected setups

        Used in payment/refund/dispute responses to indicate who initiated the
        operation

        None indicates a standard merchant flow / JWT flow / Admin flow or
        insufficient information
      enum:
        - platform
        - connected
    PaymentMethodDataResponseWithBilling:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponse'
          nullable: true
        - type: object
          properties:
            billing:
              allOf:
                - $ref: '#/components/schemas/Address'
              nullable: true
    ErrorDetails:
      type: object
      description: Error details for the payment
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: The error code
          example: card_declined
        message:
          type: string
          description: The error message
          example: The card was declined.
        reason:
          type: string
          description: The detailed error reason that was returned by the connector.
          example: The card was declined.
          nullable: true
        unified_code:
          type: string
          description: |-
            The unified error code across all connectors.
            This can be relied upon for taking decisions based on the error.
          example: card_declined
          nullable: true
        unified_message:
          type: string
          description: >-
            The unified error message across all connectors.

            If there is a translation available, this will have the translated
            message
          example: The card was declined.
          nullable: true
        network_advice_code:
          type: string
          description: >-
            This field can be returned for both approved and refused Mastercard
            payments.

            This code provides additional information about the type of
            transaction or the reason why the payment failed.

            If the payment failed, the network advice code gives guidance on if
            and when you can retry the payment.
          example: '01'
          nullable: true
        network_decline_code:
          type: string
          description: >-
            For card errors resulting from a card issuer decline, a brand
            specific 2, 3, or 4 digit code which indicates the reason the
            authorization failed.
          example: '05'
          nullable: true
        network_error_message:
          type: string
          description: >-
            A string indicating how to proceed with an network error if payment
            gateway provide one. This is used to understand the network error
            code better.
          example: Do not retry
          nullable: true
    PaymentAttemptResponse:
      type: object
      required:
        - id
        - status
        - amount
        - authentication_type
        - created_at
        - modified_at
        - connector_payment_id
      properties:
        id:
          type: string
          description: The global identifier for the payment attempt
        status:
          $ref: '#/components/schemas/AttemptStatus'
        amount:
          $ref: '#/components/schemas/PaymentAttemptAmountDetails'
        connector:
          type: string
          description: Name of the connector that was used for the payment attempt.
          example: stripe
          nullable: true
        error:
          allOf:
            - $ref: '#/components/schemas/ErrorDetails'
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: three_ds
        created_at:
          type: string
          format: date-time
          description: Date and time of Payment attempt creation
        modified_at:
          type: string
          format: date-time
          description: Time at which the payment attempt was last modified
        cancellation_reason:
          type: string
          description: >-
            The reason for the cancellation of the payment attempt. Some
            connectors will have strict rules regarding the values this can have

            Cancellation reason will be validated at the connector level when
            building the request
          nullable: true
        payment_token:
          type: string
          description: >-
            Payment token is the token used for temporary use in case the
            payment method is stored in vault
          example: 187282ab-40ef-47a9-9206-5099ba31e432
          nullable: true
        connector_metadata:
          allOf:
            - $ref: '#/components/schemas/ConnectorMetadata'
          nullable: true
        payment_experience:
          allOf:
            - $ref: '#/components/schemas/PaymentExperience'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethod'
          nullable: true
        connector_reference_id:
          type: string
          description: reference(Identifier) to the payment at connector side
          example: 993672945374576J
          nullable: true
        payment_method_subtype:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        connector_payment_id:
          type: string
          description: A unique identifier for a payment provided by the connector
        payment_method_id:
          type: string
          description: Identifier for Payment Method used for the payment attempt
          example: 0a_pm_01926c58bc6e77c09e809964e72af8c8
          nullable: true
        client_source:
          type: string
          description: >-
            Value passed in X-CLIENT-SOURCE header during payments confirm
            request by the client
          nullable: true
        client_version:
          type: string
          description: >-
            Value passed in X-CLIENT-VERSION header during payments confirm
            request by the client
          nullable: true
        feature_metadata:
          allOf:
            - $ref: '#/components/schemas/PaymentAttemptFeatureMetadata'
          nullable: true
        payment_method_data:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponseWithBilling'
          nullable: true
    ConnectorTokenDetails:
      type: object
      description: >-
        Token information that can be used to initiate transactions by the
        merchant.
      required:
        - token
      properties:
        token:
          type: string
          description: >-
            A token that can be used to make payments directly with the
            connector.
          example: pm_9UhMqBMEOooRIvJFFdeW
        connector_token_request_reference_id:
          type: string
          description: The reference id sent to the connector when creating the token
          nullable: true
    NextActionData:
      oneOf:
        - type: object
          description: Contains the url for redirection flow
          required:
            - redirect_to_url
            - type
          properties:
            redirect_to_url:
              type: string
              example: https://example.com/redirect
            type:
              type: string
              enum:
                - redirect_to_url
        - type: object
          description: >-
            Informs the next steps for bank transfer and also contains the
            charges details (ex: amount received, amount charged etc)
          required:
            - bank_transfer_steps_and_charges_details
            - type
          properties:
            bank_transfer_steps_and_charges_details:
              $ref: '#/components/schemas/BankTransferNextStepsData'
            type:
              type: string
              enum:
                - display_bank_transfer_information
        - type: object
          description: Contains third party sdk session token response
          required:
            - type
          properties:
            session_token:
              allOf:
                - $ref: '#/components/schemas/SessionToken'
              nullable: true
            type:
              type: string
              enum:
                - third_party_sdk_session_token
        - type: object
          description: Contains url for Qr code image, this qr code has to be shown in sdk
          required:
            - image_data_url
            - qr_code_url
            - type
          properties:
            image_data_url:
              type: string
              description: Hyperswitch generated image data source url
            display_to_timestamp:
              type: integer
              format: int64
              nullable: true
            qr_code_url:
              type: string
              description: The url for Qr code given by the connector
            display_text:
              type: string
              nullable: true
            border_color:
              type: string
              nullable: true
            raw_qr_data:
              type: string
              description: >-
                The raw QR code data (EMV copy and paste) used for Brazilian
                payment methods like Pix
              nullable: true
            type:
              type: string
              enum:
                - qr_code_information
        - type: object
          description: Contains url to fetch Qr code data
          required:
            - qr_code_fetch_url
            - type
          properties:
            qr_code_fetch_url:
              type: string
            type:
              type: string
              enum:
                - fetch_qr_code_information
        - type: object
          required:
            - sdk_uri
            - display_from_timestamp
            - type
          properties:
            sdk_uri:
              type: string
            display_from_timestamp:
              type: integer
            display_to_timestamp:
              type: integer
              nullable: true
            poll_config:
              allOf:
                - $ref: '#/components/schemas/PollConfig'
              nullable: true
            type:
              type: string
              enum:
                - invoke_upi_intent_sdk
        - type: object
          required:
            - qr_code_url
            - display_from_timestamp
            - type
          properties:
            qr_code_url:
              type: string
            display_from_timestamp:
              type: integer
            display_to_timestamp:
              type: integer
              nullable: true
            poll_config:
              allOf:
                - $ref: '#/components/schemas/PollConfig'
              nullable: true
            type:
              type: string
              enum:
                - invoke_upi_qr_flow
        - type: object
          description: Contains the download url and the reference number for transaction
          required:
            - voucher_details
            - type
          properties:
            voucher_details:
              type: string
            type:
              type: string
              enum:
                - display_voucher_information
        - type: object
          description: >-
            Contains duration for displaying a wait screen, wait screen with
            timer is displayed by sdk
          required:
            - display_from_timestamp
            - type
          properties:
            display_from_timestamp:
              type: integer
            display_to_timestamp:
              type: integer
              nullable: true
            poll_config:
              allOf:
                - $ref: '#/components/schemas/PollConfig'
              nullable: true
            type:
              type: string
              enum:
                - wait_screen_information
        - type: object
          description: >-
            Contains the information regarding three_ds_method_data submission,
            three_ds authentication, and authorization flows
          required:
            - three_ds_data
            - type
          properties:
            three_ds_data:
              $ref: '#/components/schemas/ThreeDsData'
            type:
              type: string
              enum:
                - three_ds_invoke
        - type: object
          required:
            - next_action_data
            - type
          properties:
            next_action_data:
              $ref: '#/components/schemas/SdkNextActionData'
            type:
              type: string
              enum:
                - invoke_sdk_client
        - type: object
          description: Contains consent to collect otp for mobile payment
          required:
            - consent_data_required
            - type
          properties:
            consent_data_required:
              $ref: '#/components/schemas/MobilePaymentConsent'
            type:
              type: string
              enum:
                - collect_otp
        - type: object
          description: Contains data required to invoke hidden iframe
          required:
            - iframe_data
            - type
          properties:
            iframe_data:
              $ref: '#/components/schemas/IframeData'
            type:
              type: string
              enum:
                - invoke_hidden_iframe
        - type: object
          description: >-
            The data required to trigger the DDC (Device Data Collection) flow
            by rendering the provided URL in a hidden iframe.
          required:
            - ddc_data
            - type
          properties:
            ddc_data:
              $ref: '#/components/schemas/DDCData'
            type:
              type: string
              enum:
                - invoke_ddc
      discriminator:
        propertyName: type
    AuthenticationType:
      type: string
      description: >-
        Specifies the type of cardholder authentication to be applied for a
        payment.


        - `ThreeDs`: Requests 3D Secure (3DS) authentication. If the card is
        enrolled, 3DS authentication will be activated, potentially shifting
        chargeback liability to the issuer.

        - `NoThreeDs`: Indicates that 3D Secure authentication should not be
        performed. The liability for chargebacks typically remains with the
        merchant. This is often the default if not specified.


        Note: The actual authentication behavior can also be influenced by
        merchant configuration and specific connector defaults. Some connectors
        might still enforce 3DS or bypass it regardless of this parameter.
      enum:
        - three_ds
        - no_three_ds
    FeatureMetadata:
      type: object
      description: additional data that might be required by hyperswitch
      properties:
        redirect_response:
          allOf:
            - $ref: '#/components/schemas/RedirectResponse'
          nullable: true
        search_tags:
          type: array
          items:
            type: string
          description: Additional tags to be used for global search
          nullable: true
        apple_pay_recurring_details:
          allOf:
            - $ref: '#/components/schemas/ApplePayRecurringDetails'
          nullable: true
        revenue_recovery:
          allOf:
            - $ref: '#/components/schemas/PaymentRevenueRecoveryMetadata'
          nullable: true
        pix_additional_details:
          allOf:
            - $ref: '#/components/schemas/PixAdditionalDetails'
          nullable: true
        boleto_additional_details:
          allOf:
            - $ref: '#/components/schemas/BoletoAdditionalDetails'
          nullable: true
        pix_automatico_additional_details:
          allOf:
            - $ref: '#/components/schemas/PixAutomaticoAdditionalDetails'
          nullable: true
        finix_additional_details:
          allOf:
            - $ref: '#/components/schemas/FinixAdditionalDetails'
          nullable: true
    PaymentMethodData:
      oneOf:
        - type: object
          title: Card
          required:
            - card
          properties:
            card:
              $ref: '#/components/schemas/Card'
        - type: object
          title: CardRedirect
          required:
            - card_redirect
          properties:
            card_redirect:
              $ref: '#/components/schemas/CardRedirectData'
        - type: object
          title: Wallet
          required:
            - wallet
          properties:
            wallet:
              $ref: '#/components/schemas/WalletData'
        - type: object
          title: PayLater
          required:
            - pay_later
          properties:
            pay_later:
              $ref: '#/components/schemas/PayLaterData'
        - type: object
          title: BankRedirect
          required:
            - bank_redirect
          properties:
            bank_redirect:
              $ref: '#/components/schemas/BankRedirectData'
        - type: object
          title: BankDebit
          required:
            - bank_debit
          properties:
            bank_debit:
              $ref: '#/components/schemas/BankDebitData'
        - type: object
          title: BankTransfer
          required:
            - bank_transfer
          properties:
            bank_transfer:
              $ref: '#/components/schemas/BankTransferData'
        - type: object
          title: RealTimePayment
          required:
            - real_time_payment
          properties:
            real_time_payment:
              $ref: '#/components/schemas/RealTimePaymentData'
        - type: object
          title: Crypto
          required:
            - crypto
          properties:
            crypto:
              $ref: '#/components/schemas/CryptoData'
        - type: string
          title: MandatePayment
          enum:
            - mandate_payment
        - type: string
          title: Reward
          enum:
            - reward
        - type: object
          title: Upi
          required:
            - upi
          properties:
            upi:
              $ref: '#/components/schemas/UpiData'
        - type: object
          title: Voucher
          required:
            - voucher
          properties:
            voucher:
              $ref: '#/components/schemas/VoucherData'
        - type: object
          title: GiftCard
          required:
            - gift_card
          properties:
            gift_card:
              $ref: '#/components/schemas/GiftCardData'
        - type: object
          title: CardToken
          required:
            - card_token
          properties:
            card_token:
              $ref: '#/components/schemas/CardToken'
        - type: object
          title: OpenBanking
          required:
            - open_banking
          properties:
            open_banking:
              $ref: '#/components/schemas/OpenBankingData'
        - type: object
          title: MobilePayment
          required:
            - mobile_payment
          properties:
            mobile_payment:
              $ref: '#/components/schemas/MobilePaymentData'
        - type: object
          title: NetworkToken
          required:
            - network_token
          properties:
            network_token:
              $ref: '#/components/schemas/NetworkTokenData'
        - type: object
          title: VaultDataCard
          required:
            - vault_data_card
          properties:
            vault_data_card:
              $ref: '#/components/schemas/ProxyCardData'
        - type: object
          title: VaultCardTokenData
          required:
            - vault_card_token_data
          properties:
            vault_card_token_data:
              $ref: '#/components/schemas/VaultCardToken'
    AddressDetails:
      type: object
      description: Address details
      properties:
        city:
          type: string
          description: The city, district, suburb, town, or village of the address.
          example: New York
          nullable: true
          maxLength: 50
        country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        line1:
          type: string
          description: The first line of the street address or P.O. Box.
          example: 123, King Street
          nullable: true
          maxLength: 200
        line2:
          type: string
          description: >-
            The second line of the street address or P.O. Box (e.g., apartment,
            suite, unit, or building).
          example: Powelson Avenue
          nullable: true
          maxLength: 50
        line3:
          type: string
          description: The third line of the street address, if applicable.
          example: Bridgewater
          nullable: true
          maxLength: 50
        zip:
          type: string
          description: The zip/postal code for the address
          example: '08807'
          nullable: true
          maxLength: 50
        state:
          type: string
          description: The address state
          example: New York
          nullable: true
        first_name:
          type: string
          description: The first name for the address
          example: John
          nullable: true
          maxLength: 255
        last_name:
          type: string
          description: The last name for the address
          example: Doe
          nullable: true
          maxLength: 255
        origin_zip:
          type: string
          description: The zip/postal code of the origin
          example: '08807'
          nullable: true
          maxLength: 50
    PhoneDetails:
      type: object
      properties:
        number:
          type: string
          description: The contact number
          example: '9123456789'
          nullable: true
        country_code:
          type: string
          description: The country code attached to the number
          example: '+1'
          nullable: true
    AcceptanceType:
      type: string
      description: This is used to indicate if the mandate was accepted online or offline
      enum:
        - online
        - offline
    OnlineMandate:
      type: object
      description: Details of online mandate
      required:
        - ip_address
        - user_agent
      properties:
        ip_address:
          type: string
          description: >-
            Ip address of the customer machine from which the mandate was
            created
          example: 123.32.25.123
        user_agent:
          type: string
          description: The user-agent of the customer's browser
      additionalProperties: false
    Connector:
      type: string
      enum:
        - absa_sanlam
        - authipay
        - adyenplatform
        - stripe_billing_test
        - phonypay
        - fauxpay
        - pretendpay
        - stripe_test
        - adyen_test
        - checkout_test
        - paypal_test
        - aci
        - adyen
        - affirm
        - airwallex
        - amazonpay
        - archipel
        - authorizedotnet
        - bambora
        - bamboraapac
        - bankofamerica
        - barclaycard
        - billwerk
        - bitpay
        - bluesnap
        - blackhawknetwork
        - calida
        - boku
        - braintree
        - breadpay
        - cardinal
        - cashtocode
        - celero
        - chargebee
        - checkbook
        - checkout
        - coinbase
        - coingate
        - custombilling
        - cryptopay
        - ctp_mastercard
        - ctp_visa
        - cybersource
        - cybersourcedecisionmanager
        - datatrans
        - deutschebank
        - digitalvirgo
        - dlocal
        - dwolla
        - ebanx
        - envoy
        - elavon
        - facilitapay
        - finix
        - fiserv
        - fiservemea
        - fiservcommercehub
        - fiuu
        - flexiti
        - forte
        - getnet
        - gigadat
        - globalpay
        - globepay
        - gocardless
        - gpayments
        - hipay
        - helcim
        - hyperpg
        - hyperswitch_vault
        - interpayments
        - inespay
        - iatapay
        - imerchantsolutions
        - itaubank
        - jpmorgan
        - juspaythreedsserver
        - klarna
        - loonio
        - mifinity
        - mollie
        - moneris
        - multisafepay
        - netcetera
        - nexinets
        - nexixpay
        - nmi
        - nomupay
        - noon
        - nordea
        - novalnet
        - nuvei
        - opennode
        - paybox
        - payload
        - payme
        - payone
        - paypal
        - paysafe
        - paystack
        - paytm
        - payconex
        - payu
        - peachpayments
        - payjustnow
        - payjustnowinstore
        - phonepe
        - placetopay
        - powertranz
        - prophetpay
        - rapyd
        - razorpay
        - recurly
        - redsys
        - revolv3
        - santander
        - shift4
        - silverflow
        - square
        - stax
        - stripe
        - stripebilling
        - taxjar
        - threedsecureio
        - tesouro
        - tokenex
        - tokenio
        - trustly
        - truelayer
        - trustpay
        - trustpayments
        - tsys
        - tsys_transit
        - vgs
        - volt
        - wellsfargo
        - wise
        - worldline
        - worldpay
        - worldpayvantiv
        - worldpayxml
        - worldpaymodular
        - signifyd
        - plaid
        - riskified
        - xendit
        - zen
        - zift
        - zsl
    Currency:
      type: string
      description: >-
        The three-letter ISO 4217 currency code (e.g., "USD", "EUR") for the
        payment amount. This field is mandatory for creating a payment.
      enum:
        - AED
        - AFN
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BRL
        - BSD
        - BTN
        - BWP
        - BYN
        - BZD
        - CAD
        - CDF
        - CHF
        - CLF
        - CLP
        - CNY
        - COP
        - CRC
        - CUC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ERN
        - ETB
        - EUR
        - FJD
        - FKP
        - GBP
        - GEL
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - INR
        - IQD
        - IRR
        - ISK
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KPW
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRU
        - MUR
        - MVR
        - MWK
        - MXN
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SDG
        - SEK
        - SGD
        - SHP
        - SLE
        - SLL
        - SOS
        - SRD
        - SSP
        - STD
        - STN
        - SVC
        - SYP
        - SZL
        - THB
        - TJS
        - TMT
        - TND
        - TOP
        - TRY
        - TTD
        - TWD
        - TZS
        - UAH
        - UGX
        - USD
        - UYU
        - UZS
        - VES
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XOF
        - XPF
        - YER
        - ZAR
        - ZMW
        - ZWL
    MinorUnit:
      type: integer
      format: int64
      description: This Unit struct represents MinorUnit in which core amount works
    TaxCalculationOverride:
      type: string
      enum:
        - skip
        - calculate
    SurchargeCalculationOverride:
      type: string
      enum:
        - skip
        - calculate
    PaymentMethodDataResponse:
      oneOf:
        - type: object
          required:
            - card
          properties:
            card:
              $ref: '#/components/schemas/CardResponse'
        - type: object
          required:
            - bank_transfer
          properties:
            bank_transfer:
              $ref: '#/components/schemas/BankTransferResponse'
        - type: object
          required:
            - wallet
          properties:
            wallet:
              $ref: '#/components/schemas/WalletResponse'
        - type: object
          required:
            - pay_later
          properties:
            pay_later:
              $ref: '#/components/schemas/PaylaterResponse'
        - type: object
          required:
            - bank_redirect
          properties:
            bank_redirect:
              $ref: '#/components/schemas/BankRedirectResponse'
        - type: object
          required:
            - crypto
          properties:
            crypto:
              $ref: '#/components/schemas/CryptoResponse'
        - type: object
          required:
            - bank_debit
          properties:
            bank_debit:
              $ref: '#/components/schemas/BankDebitResponse'
        - type: object
          required:
            - mandate_payment
          properties:
            mandate_payment:
              type: object
        - type: object
          required:
            - reward
          properties:
            reward:
              type: object
        - type: object
          required:
            - real_time_payment
          properties:
            real_time_payment:
              $ref: '#/components/schemas/RealTimePaymentDataResponse'
        - type: object
          required:
            - upi
          properties:
            upi:
              $ref: '#/components/schemas/UpiResponse'
        - type: object
          required:
            - voucher
          properties:
            voucher:
              $ref: '#/components/schemas/VoucherResponse'
        - type: object
          required:
            - gift_card
          properties:
            gift_card:
              $ref: '#/components/schemas/GiftCardResponse'
        - type: object
          required:
            - card_redirect
          properties:
            card_redirect:
              $ref: '#/components/schemas/CardRedirectResponse'
        - type: object
          required:
            - card_token
          properties:
            card_token:
              $ref: '#/components/schemas/CardTokenResponse'
        - type: object
          required:
            - open_banking
          properties:
            open_banking:
              $ref: '#/components/schemas/OpenBankingResponse'
        - type: object
          required:
            - mobile_payment
          properties:
            mobile_payment:
              $ref: '#/components/schemas/MobilePaymentResponse'
        - type: object
          required:
            - network_token
          properties:
            network_token:
              $ref: '#/components/schemas/NetworkTokenResponse'
    AttemptStatus:
      type: string
      description: The status of the attempt
      enum:
        - started
        - authentication_failed
        - router_declined
        - authentication_pending
        - authentication_successful
        - authorized
        - authorization_failed
        - charged
        - authorizing
        - cod_initiated
        - voided
        - voided_post_charge
        - void_initiated
        - capture_initiated
        - capture_failed
        - void_failed
        - auto_refunded
        - partial_charged
        - partially_authorized
        - partial_charged_and_chargeable
        - unresolved
        - pending
        - failure
        - payment_method_awaited
        - confirmation_awaited
        - device_data_collection_pending
        - integrity_failure
        - expired
        - capture_review
    PaymentAttemptAmountDetails:
      type: object
      required:
        - net_amount
        - amount_capturable
      properties:
        net_amount:
          $ref: '#/components/schemas/MinorUnit'
        amount_to_capture:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        surcharge_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        tax_on_surcharge:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        amount_capturable:
          $ref: '#/components/schemas/MinorUnit'
        shipping_cost:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        order_tax_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        amount_captured:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
    ConnectorMetadata:
      type: object
      description: >-
        Some connectors like Apple Pay, Airwallex and Noon might require some
        additional information, find specific details in the child attributes
        below.
      properties:
        apple_pay:
          allOf:
            - $ref: '#/components/schemas/ApplepayConnectorMetadataRequest'
          nullable: true
        airwallex:
          allOf:
            - $ref: '#/components/schemas/AirwallexData'
          nullable: true
        noon:
          allOf:
            - $ref: '#/components/schemas/NoonData'
          nullable: true
        braintree:
          allOf:
            - $ref: '#/components/schemas/BraintreeData'
          nullable: true
        adyen:
          allOf:
            - $ref: '#/components/schemas/AdyenConnectorMetadata'
          nullable: true
        peachpayments:
          allOf:
            - $ref: '#/components/schemas/PeachpaymentsData'
          nullable: true
        santander:
          allOf:
            - $ref: '#/components/schemas/SantanderConnectorMetadataData'
          nullable: true
    PaymentExperience:
      type: string
      description: >-
        To indicate the type of payment experience that the customer would go
        through
      enum:
        - redirect_to_url
        - invoke_sdk_client
        - display_qr_code
        - one_click
        - link_wallet
        - invoke_payment_app
        - display_wait_screen
        - collect_otp
    PaymentAttemptFeatureMetadata:
      type: object
      properties:
        revenue_recovery:
          allOf:
            - $ref: '#/components/schemas/PaymentAttemptRevenueRecoveryData'
          nullable: true
    BankTransferNextStepsData:
      allOf:
        - $ref: '#/components/schemas/BankTransferInstructions'
        - type: object
          properties:
            receiver:
              allOf:
                - $ref: '#/components/schemas/ReceiverDetails'
              nullable: true
    SessionToken:
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/GpaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - google_pay
        - allOf:
            - $ref: '#/components/schemas/SamsungPaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - samsung_pay
        - allOf:
            - $ref: '#/components/schemas/KlarnaSessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - klarna
        - allOf:
            - $ref: '#/components/schemas/PaypalSessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - paypal
        - allOf:
            - $ref: '#/components/schemas/ApplepaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - apple_pay
        - allOf:
            - $ref: '#/components/schemas/OpenBankingSessionToken'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - open_banking
        - allOf:
            - $ref: '#/components/schemas/PazeSessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - paze
        - allOf:
            - $ref: '#/components/schemas/ClickToPaySessionResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - click_to_pay
        - allOf:
            - $ref: '#/components/schemas/AmazonPaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - amazon_pay
        - type: object
          required:
            - wallet_name
          properties:
            wallet_name:
              type: string
              enum:
                - no_session_token_received
      discriminator:
        propertyName: wallet_name
    PollConfig:
      type: object
      required:
        - delay_in_secs
        - frequency
      properties:
        delay_in_secs:
          type: integer
          format: int32
          description: Interval of the poll
          minimum: 0
        frequency:
          type: integer
          format: int32
          description: Frequency of the poll
          minimum: 0
    ThreeDsData:
      type: object
      required:
        - three_ds_authentication_url
        - three_ds_authorize_url
        - three_ds_method_details
        - poll_config
      properties:
        three_ds_authentication_url:
          type: string
          description: ThreeDS authentication url - to initiate authentication
        three_ds_authorize_url:
          type: string
          description: >-
            ThreeDS authorize url - to complete the payment authorization after
            authentication
        three_ds_method_details:
          $ref: '#/components/schemas/ThreeDsMethodData'
        poll_config:
          $ref: '#/components/schemas/PollConfigResponse'
        message_version:
          type: string
          description: Message Version
          nullable: true
        directory_server_id:
          type: string
          description: Directory Server ID
          nullable: true
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        three_ds_connector:
          type: string
          description: Preferred 3ds Connector
          nullable: true
    SdkNextActionData:
      type: object
      required:
        - next_action
      properties:
        next_action:
          $ref: '#/components/schemas/NextActionCall'
        order_id:
          type: string
          nullable: true
    MobilePaymentConsent:
      type: string
      enum:
        - consent_required
        - consent_not_required
        - consent_optional
    IframeData:
      oneOf:
        - type: object
          required:
            - three_ds_method_url
            - three_ds_method_data_submission
            - directory_server_id
            - method_key
          properties:
            three_ds_method_url:
              type: string
              description: ThreeDS method url
            three_ds_method_data_submission:
              type: boolean
              description: Whether ThreeDS method data submission is required
            three_ds_method_data:
              type: string
              description: ThreeDS method data
              nullable: true
            directory_server_id:
              type: string
              description: ThreeDS Server ID
            message_version:
              type: string
              description: ThreeDS Protocol version
              nullable: true
            method_key:
              type: string
              enum:
                - threeDSMethodData
      discriminator:
        propertyName: method_key
    DDCData:
      type: object
      required:
        - iframe_url
      properties:
        iframe_url:
          type: string
        timeout_ms:
          type: integer
          format: int32
          nullable: true
    RedirectResponse:
      type: object
      properties:
        param:
          type: string
          nullable: true
        json_payload:
          type: object
          nullable: true
    ApplePayRecurringDetails:
      type: object
      required:
        - payment_description
        - regular_billing
        - management_url
      properties:
        payment_description:
          type: string
          description: >-
            A description of the recurring payment that Apple Pay displays to
            the user in the payment sheet
        regular_billing:
          $ref: '#/components/schemas/ApplePayRegularBillingDetails'
        billing_agreement:
          type: string
          description: >-
            A localized billing agreement that the payment sheet displays to the
            user before the user authorizes the payment
          nullable: true
        management_url:
          type: string
          description: >-
            A URL to a web page where the user can update or delete the payment
            method for the recurring payment
          example: https://hyperswitch.io
    PaymentRevenueRecoveryMetadata:
      type: object
      required:
        - total_retry_count
        - billing_connector_id
        - active_attempt_payment_connector_id
        - billing_connector_payment_details
        - payment_method_type
        - payment_method_subtype
        - connector
        - billing_connector_payment_method_details
      properties:
        total_retry_count:
          type: integer
          format: int32
          description: >-
            Total number of billing connector + recovery retries for a payment
            intent.
          example: '1'
          minimum: 0
        payment_connector_transmission:
          allOf:
            - $ref: '#/components/schemas/PaymentConnectorTransmission'
          nullable: true
        billing_connector_id:
          type: string
          description: Billing Connector Id to update the invoices
          example: mca_1234567890
        active_attempt_payment_connector_id:
          type: string
          description: Payment Connector Id to retry the payments
          example: mca_1234567890
        billing_connector_payment_details:
          $ref: '#/components/schemas/BillingConnectorPaymentDetails'
        payment_method_type:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_subtype:
          $ref: '#/components/schemas/PaymentMethodType'
        connector:
          $ref: '#/components/schemas/Connector'
        billing_connector_payment_method_details:
          $ref: '#/components/schemas/BillingConnectorPaymentMethodDetails'
        invoice_next_billing_time:
          type: string
          format: date-time
          description: Invoice Next billing time
          nullable: true
        invoice_billing_started_at_time:
          type: string
          format: date-time
          description: Invoice Next billing time
          nullable: true
        first_payment_attempt_pg_error_code:
          type: string
          description: First Payment Attempt Payment Gateway Error Code
          example: card_declined
          nullable: true
        first_payment_attempt_network_decline_code:
          type: string
          description: First Payment Attempt Network Error Code
          example: '05'
          nullable: true
        first_payment_attempt_network_advice_code:
          type: string
          description: First Payment Attempt Network Advice Code
          example: '02'
          nullable: true
    PixAdditionalDetails:
      oneOf:
        - type: object
          required:
            - immediate
          properties:
            immediate:
              $ref: '#/components/schemas/ImmediateExpirationTime'
        - type: object
          required:
            - scheduled
          properties:
            scheduled:
              $ref: '#/components/schemas/ScheduledExpirationTime'
    BoletoAdditionalDetails:
      type: object
      properties:
        due_date:
          type: string
          description: Due Date for the Boleto
          example: '2026-12-31'
          nullable: true
        document_kind:
          allOf:
            - $ref: '#/components/schemas/BoletoDocumentKind'
          nullable: true
        payment_type:
          allOf:
            - $ref: '#/components/schemas/BoletoPaymentType'
          nullable: true
        covenant_code:
          type: string
          example: '3568253'
          nullable: true
        pix_key:
          allOf:
            - $ref: '#/components/schemas/PixKey'
          nullable: true
        discount_rules:
          allOf:
            - $ref: '#/components/schemas/SantanderPaymentDiscountRules'
          nullable: true
        penalties:
          allOf:
            - $ref: '#/components/schemas/PenaltyRules'
          nullable: true
        collection_actions:
          allOf:
            - $ref: '#/components/schemas/CollectionActions'
          nullable: true
        payment_constraints:
          allOf:
            - $ref: '#/components/schemas/BoletoPaymentTypeConstraints'
          nullable: true
        beneficiary:
          allOf:
            - $ref: '#/components/schemas/BeneficiaryDetails'
          nullable: true
    PixAutomaticoAdditionalDetails:
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/PixAutomaticoPushData'
            - type: object
              required:
                - type
              properties:
                type:
                  type: string
                  enum:
                    - pix_automatico_push
        - allOf:
            - $ref: '#/components/schemas/PixAutomaticoQrData'
            - type: object
              required:
                - type
              properties:
                type:
                  type: string
                  enum:
                    - pix_automatico_qr
        - allOf:
            - $ref: '#/components/schemas/PixAutomaticoMitData'
            - type: object
              required:
                - type
              properties:
                type:
                  type: string
                  enum:
                    - pix_automatico_mit
      description: >-
        Represents the specific data for Santander Pix Automatico (recurring PIX
        payments)

        Split into CIT (Customer Initiated Transaction) and MIT (Merchant
        Initiated Transaction) variants
      discriminator:
        propertyName: type
    FinixAdditionalDetails:
      type: object
      properties:
        fraud_session_id:
          type: string
          description: The fraud session ID used for Finix fraud detection
          example: 1234567890abcdef
          nullable: true
    Card:
      type: object
      required:
        - card_number
        - card_exp_month
        - card_exp_year
        - card_holder_name
        - card_cvc
      properties:
        card_number:
          type: string
          description: The card number
          example: '4242424242424242'
        card_exp_month:
          type: string
          description: The card's expiry month
          example: '24'
        card_exp_year:
          type: string
          description: The card's expiry year
          example: '24'
        card_holder_name:
          type: string
          description: The card holder's name
          example: John Test
        card_cvc:
          type: string
          description: The CVC number for the card
          example: '242'
        card_issuer:
          type: string
          description: The name of the issuer of card
          example: chase
          nullable: true
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        card_type:
          type: string
          example: CREDIT
          nullable: true
        card_issuing_country:
          type: string
          example: INDIA
          nullable: true
        card_issuing_country_code:
          type: string
          example: IN
          nullable: true
        bank_code:
          type: string
          example: JP_AMEX
          nullable: true
        nick_name:
          type: string
          description: The card holder's nick name
          example: John Test
          nullable: true
    CardRedirectData:
      oneOf:
        - type: object
          required:
            - knet
          properties:
            knet:
              type: object
        - type: object
          required:
            - benefit
          properties:
            benefit:
              type: object
        - type: object
          required:
            - momo_atm
          properties:
            momo_atm:
              type: object
        - type: object
          required:
            - card_redirect
          properties:
            card_redirect:
              type: object
    WalletData:
      oneOf:
        - type: object
          title: AliPayHkRedirect
          required:
            - ali_pay_hk_redirect
          properties:
            ali_pay_hk_redirect:
              $ref: '#/components/schemas/AliPayHkRedirection'
        - type: object
          title: AliPayQr
          required:
            - ali_pay_qr
          properties:
            ali_pay_qr:
              $ref: '#/components/schemas/AliPayQr'
        - type: object
          title: AliPayRedirect
          required:
            - ali_pay_redirect
          properties:
            ali_pay_redirect:
              $ref: '#/components/schemas/AliPayRedirection'
        - type: object
          title: AmazonPay
          required:
            - amazon_pay
          properties:
            amazon_pay:
              $ref: '#/components/schemas/AmazonPayWalletData'
        - type: object
          title: AmazonPayRedirect
          required:
            - amazon_pay_redirect
          properties:
            amazon_pay_redirect:
              $ref: '#/components/schemas/AmazonPayRedirectData'
        - type: object
          title: ApplePay
          required:
            - apple_pay
          properties:
            apple_pay:
              $ref: '#/components/schemas/ApplePayWalletData'
        - type: object
          title: ApplePayRedirect
          required:
            - apple_pay_redirect
          properties:
            apple_pay_redirect:
              $ref: '#/components/schemas/ApplePayRedirectData'
        - type: object
          title: ApplePayThirdPartySdk
          required:
            - apple_pay_third_party_sdk
          properties:
            apple_pay_third_party_sdk:
              $ref: '#/components/schemas/ApplePayThirdPartySdkData'
        - type: object
          title: BluecodeRedirect
          required:
            - bluecode_redirect
          properties:
            bluecode_redirect:
              type: object
              description: The wallet data for Bluecode QR Code Redirect
        - type: object
          title: CashappQr
          required:
            - cashapp_qr
          properties:
            cashapp_qr:
              $ref: '#/components/schemas/CashappQr'
        - type: object
          title: DanaRedirect
          required:
            - dana_redirect
          properties:
            dana_redirect:
              type: object
              description: Wallet data for DANA redirect flow
        - type: object
          title: GcashRedirect
          required:
            - gcash_redirect
          properties:
            gcash_redirect:
              $ref: '#/components/schemas/GcashRedirection'
        - type: object
          title: GoPayRedirect
          required:
            - go_pay_redirect
          properties:
            go_pay_redirect:
              $ref: '#/components/schemas/GoPayRedirection'
        - type: object
          title: GooglePay
          required:
            - google_pay
          properties:
            google_pay:
              $ref: '#/components/schemas/GooglePayWalletData'
        - type: object
          title: GooglePayRedirect
          required:
            - google_pay_redirect
          properties:
            google_pay_redirect:
              $ref: '#/components/schemas/GooglePayRedirectData'
        - type: object
          title: GooglePayThirdPartySdk
          required:
            - google_pay_third_party_sdk
          properties:
            google_pay_third_party_sdk:
              $ref: '#/components/schemas/GooglePayThirdPartySdkData'
        - type: object
          title: KakaoPayRedirect
          required:
            - kakao_pay_redirect
          properties:
            kakao_pay_redirect:
              $ref: '#/components/schemas/KakaoPayRedirection'
        - type: object
          title: MbWayRedirect
          required:
            - mb_way_redirect
          properties:
            mb_way_redirect:
              $ref: '#/components/schemas/MbWayRedirection'
        - type: object
          title: Mifinity
          required:
            - mifinity
          properties:
            mifinity:
              $ref: '#/components/schemas/MifinityData'
        - type: object
          title: MobilePayRedirect
          required:
            - mobile_pay_redirect
          properties:
            mobile_pay_redirect:
              $ref: '#/components/schemas/MobilePayRedirection'
        - type: object
          title: MomoRedirect
          required:
            - momo_redirect
          properties:
            momo_redirect:
              $ref: '#/components/schemas/MomoRedirection'
        - type: object
          title: PaypalRedirect
          required:
            - paypal_redirect
          properties:
            paypal_redirect:
              $ref: '#/components/schemas/PaypalRedirection'
        - type: object
          title: PaypalSdk
          required:
            - paypal_sdk
          properties:
            paypal_sdk:
              $ref: '#/components/schemas/PayPalWalletData'
        - type: object
          title: Paysera
          required:
            - paysera
          properties:
            paysera:
              $ref: '#/components/schemas/PayseraData'
        - type: object
          title: Paze
          required:
            - paze
          properties:
            paze:
              $ref: '#/components/schemas/PazeWalletData'
        - type: object
          title: RevolutPay
          required:
            - revolut_pay
          properties:
            revolut_pay:
              $ref: '#/components/schemas/RevolutPayData'
        - type: object
          title: SamsungPay
          required:
            - samsung_pay
          properties:
            samsung_pay:
              $ref: '#/components/schemas/SamsungPayWalletData'
        - type: object
          title: Skrill
          required:
            - skrill
          properties:
            skrill:
              $ref: '#/components/schemas/SkrillData'
        - type: object
          title: SwishQr
          required:
            - swish_qr
          properties:
            swish_qr:
              $ref: '#/components/schemas/SwishQrData'
        - type: object
          title: TouchNGoRedirect
          required:
            - touch_n_go_redirect
          properties:
            touch_n_go_redirect:
              $ref: '#/components/schemas/TouchNGoRedirection'
        - type: object
          title: TwintRedirect
          required:
            - twint_redirect
          properties:
            twint_redirect:
              type: object
              description: Wallet data for Twint Redirection
        - type: object
          title: VippsRedirect
          required:
            - vipps_redirect
          properties:
            vipps_redirect:
              type: object
              description: Wallet data for Vipps Redirection
        - type: object
          title: WeChatPayQr
          required:
            - we_chat_pay_qr
          properties:
            we_chat_pay_qr:
              $ref: '#/components/schemas/WeChatPayQr'
        - type: object
          title: WeChatPayRedirect
          required:
            - we_chat_pay_redirect
          properties:
            we_chat_pay_redirect:
              $ref: '#/components/schemas/WeChatPayRedirection'
    PayLaterData:
      oneOf:
        - type: object
          required:
            - klarna_redirect
          properties:
            klarna_redirect:
              type: object
              description: For KlarnaRedirect as PayLater Option
              properties:
                billing_email:
                  type: string
                  description: The billing email
                  nullable: true
                billing_country:
                  allOf:
                    - $ref: '#/components/schemas/CountryAlpha2'
                  nullable: true
        - type: object
          required:
            - klarna_sdk
          properties:
            klarna_sdk:
              type: object
              description: For Klarna Sdk as PayLater Option
              required:
                - token
              properties:
                token:
                  type: string
                  description: The token for the sdk workflow
        - type: object
          required:
            - affirm_redirect
          properties:
            affirm_redirect:
              type: object
              description: For Affirm redirect as PayLater Option
        - type: object
          required:
            - afterpay_clearpay_redirect
          properties:
            afterpay_clearpay_redirect:
              type: object
              description: For AfterpayClearpay redirect as PayLater Option
              properties:
                billing_email:
                  type: string
                  description: The billing email
                  nullable: true
                billing_name:
                  type: string
                  description: The billing name
                  nullable: true
        - type: object
          required:
            - pay_bright_redirect
          properties:
            pay_bright_redirect:
              type: object
              description: For PayBright Redirect as PayLater Option
        - type: object
          required:
            - flexiti_redirect
          properties:
            flexiti_redirect:
              type: object
              description: For Flexiti Redirect as PayLater long term finance Option
        - type: object
          required:
            - walley_redirect
          properties:
            walley_redirect:
              type: object
              description: For WalleyRedirect as PayLater Option
        - type: object
          required:
            - alma_redirect
          properties:
            alma_redirect:
              type: object
              description: For Alma Redirection as PayLater Option
        - type: object
          required:
            - atome_redirect
          properties:
            atome_redirect:
              type: object
        - type: object
          required:
            - breadpay_redirect
          properties:
            breadpay_redirect:
              type: object
        - type: object
          required:
            - payjustnow_redirect
          properties:
            payjustnow_redirect:
              type: object
    BankRedirectData:
      oneOf:
        - type: object
          required:
            - bancontact_card
          properties:
            bancontact_card:
              type: object
              required:
                - card_number
                - card_exp_month
                - card_exp_year
                - card_holder_name
              properties:
                card_number:
                  type: string
                  description: The card number
                  example: '4242424242424242'
                card_exp_month:
                  type: string
                  description: The card's expiry month
                  example: '24'
                card_exp_year:
                  type: string
                  description: The card's expiry year
                  example: '24'
                card_holder_name:
                  type: string
                  description: The card holder's name
                  example: John Test
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankRedirectBilling'
                  nullable: true
        - type: object
          required:
            - bizum
          properties:
            bizum:
              type: object
        - type: object
          required:
            - blik
          properties:
            blik:
              type: object
              properties:
                blik_code:
                  type: string
                  nullable: true
        - type: object
          required:
            - eps
          properties:
            eps:
              type: object
              required:
                - bank_name
                - country
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankRedirectBilling'
                  nullable: true
                bank_name:
                  $ref: '#/components/schemas/BankNames'
                country:
                  $ref: '#/components/schemas/CountryAlpha2'
        - type: object
          required:
            - giropay
          properties:
            giropay:
              type: object
              required:
                - country
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankRedirectBilling'
                  nullable: true
                bank_account_bic:
                  type: string
                  description: Bank account bic code
                  nullable: true
                bank_account_iban:
                  type: string
                  description: Bank account iban
                  nullable: true
                country:
                  $ref: '#/components/schemas/CountryAlpha2'
        - type: object
          required:
            - ideal
          properties:
            ideal:
              type: object
              required:
                - bank_name
                - country
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankRedirectBilling'
                  nullable: true
                bank_name:
                  $ref: '#/components/schemas/BankNames'
                country:
                  $ref: '#/components/schemas/CountryAlpha2'
        - type: object
          required:
            - interac
          properties:
            interac:
              type: object
              properties:
                country:
                  allOf:
                    - $ref: '#/components/schemas/CountryAlpha2'
                  nullable: true
                email:
                  type: string
                  example: john.doe@example.com
                  nullable: true
        - type: object
          required:
            - online_banking_czech_republic
          properties:
            online_banking_czech_republic:
              type: object
              required:
                - issuer
              properties:
                issuer:
                  $ref: '#/components/schemas/BankNames'
        - type: object
          required:
            - online_banking_finland
          properties:
            online_banking_finland:
              type: object
              properties:
                email:
                  type: string
                  nullable: true
        - type: object
          required:
            - online_banking_poland
          properties:
            online_banking_poland:
              type: object
              required:
                - issuer
              properties:
                issuer:
                  $ref: '#/components/schemas/BankNames'
        - type: object
          required:
            - online_banking_slovakia
          properties:
            online_banking_slovakia:
              type: object
              required:
                - issuer
              properties:
                issuer:
                  $ref: '#/components/schemas/BankNames'
        - type: object
          required:
            - open_banking_uk
          properties:
            open_banking_uk:
              type: object
              required:
                - issuer
                - country
              properties:
                issuer:
                  $ref: '#/components/schemas/BankNames'
                country:
                  $ref: '#/components/schemas/CountryAlpha2'
        - type: object
          required:
            - przelewy24
          properties:
            przelewy24:
              type: object
              properties:
                bank_name:
                  allOf:
                    - $ref: '#/components/schemas/BankNames'
                  nullable: true
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankRedirectBilling'
                  nullable: true
        - type: object
          required:
            - sofort
          properties:
            sofort:
              type: object
              required:
                - country
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankRedirectBilling'
                  nullable: true
                country:
                  $ref: '#/components/schemas/CountryAlpha2'
                preferred_language:
                  type: string
                  description: The preferred language
                  example: en
                  nullable: true
        - type: object
          required:
            - trustly
          properties:
            trustly:
              type: object
              properties:
                country:
                  allOf:
                    - $ref: '#/components/schemas/CountryAlpha2'
                  nullable: true
        - type: object
          required:
            - online_banking_fpx
          properties:
            online_banking_fpx:
              type: object
              required:
                - issuer
              properties:
                issuer:
                  $ref: '#/components/schemas/BankNames'
        - type: object
          required:
            - online_banking_thailand
          properties:
            online_banking_thailand:
              type: object
              required:
                - issuer
              properties:
                issuer:
                  $ref: '#/components/schemas/BankNames'
        - type: object
          required:
            - local_bank_redirect
          properties:
            local_bank_redirect:
              type: object
        - type: object
          required:
            - eft
          properties:
            eft:
              type: object
              required:
                - provider
              properties:
                provider:
                  type: string
                  description: The preferred eft provider
                  example: ozow
        - type: object
          required:
            - open_banking
          properties:
            open_banking:
              type: object
    BankDebitData:
      oneOf:
        - type: object
          required:
            - ach_bank_debit
          properties:
            ach_bank_debit:
              type: object
              description: Payment Method data for Ach bank debit
              required:
                - account_number
                - routing_number
                - bank_account_holder_name
                - bank_name
                - bank_type
                - bank_holder_type
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankDebitBilling'
                  nullable: true
                account_number:
                  type: string
                  description: Account number for ach bank debit payment
                  example: '000123456789'
                routing_number:
                  type: string
                  description: Routing number for ach bank debit payment
                  example: '110000000'
                bank_account_holder_name:
                  type: string
                  example: John Doe
                bank_name:
                  type: string
                  example: ACH
                bank_type:
                  type: string
                  example: Checking
                bank_holder_type:
                  type: string
                  example: Personal
        - type: object
          required:
            - sepa_bank_debit
          properties:
            sepa_bank_debit:
              type: object
              required:
                - iban
                - bank_account_holder_name
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankDebitBilling'
                  nullable: true
                iban:
                  type: string
                  description: International bank account number (iban) for SEPA
                  example: DE89370400440532013000
                bank_account_holder_name:
                  type: string
                  description: Owner name for bank debit
                  example: A. Schneider
        - type: object
          required:
            - sepa_guarenteed_bank_debit
          properties:
            sepa_guarenteed_bank_debit:
              type: object
              required:
                - iban
                - bank_account_holder_name
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankDebitBilling'
                  nullable: true
                iban:
                  type: string
                  description: International bank account number (iban) for SEPA
                  example: DE89370400440532013000
                bank_account_holder_name:
                  type: string
                  description: Owner name for bank debit
                  example: A. Schneider
        - type: object
          required:
            - becs_bank_debit
          properties:
            becs_bank_debit:
              type: object
              required:
                - account_number
                - bsb_number
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankDebitBilling'
                  nullable: true
                account_number:
                  type: string
                  description: Account number for Becs payment method
                  example: '000123456'
                bsb_number:
                  type: string
                  description: Bank-State-Branch (bsb) number
                  example: '000000'
                bank_account_holder_name:
                  type: string
                  description: Owner name for bank debit
                  example: A. Schneider
                  nullable: true
        - type: object
          required:
            - bacs_bank_debit
          properties:
            bacs_bank_debit:
              type: object
              required:
                - account_number
                - sort_code
                - bank_account_holder_name
              properties:
                billing_details:
                  allOf:
                    - $ref: '#/components/schemas/BankDebitBilling'
                  nullable: true
                account_number:
                  type: string
                  description: Account number for Bacs payment method
                  example: '00012345'
                sort_code:
                  type: string
                  description: Sort code for Bacs payment method
                  example: '108800'
                bank_account_holder_name:
                  type: string
                  description: holder name for bank debit
                  example: A. Schneider
        - type: object
          required:
            - eft_debit_order
          properties:
            eft_debit_order:
              type: object
              required:
                - account_number
              properties:
                billing_details:
                  allOf:
[...]
